{% extends "layouts/base.html" %}

{% block title %}
	{{ title }}
{% endblock %}

{% block content %}
    <a class="btn btn btn-outline-secondary mb-2" href="/">←</a>
	{% include 'includes/upload.html' %}
    
	{% if data %}
        <hr>
        
        <!-- Buttons and Alert Messages -->
        {% if import_allowed %}
        <div class="container-fluid d-flex justify-content-end" id="Actions">
        <div class="form-check my-auto">
            <input class="form-check-input" type="checkbox" value="" id="overwriteUsers"  data-bs-toggle="tooltip" data-bs-placement="top" 
            data-bs-title="If you enable this option all of the users data will be overwritten (including attributes).
             If this is not checked only new Groups/Roles/Attributes will be added">
            <label class="form-check-label" for="overwriteUsers">
                Overwrite user
            </label>
        </div>
        <div id="import-button" class="d-flex justify-content-end m-2">
            <button type="button" id="submitUsers" class="btn btn-success">Import Users</button>

            <div id="importing" class="spinner-grow text-primary mb-1" role="status">
                <span class="visually-hidden">Loading...</span>
            </div>
        </div>
        </div>
        {% else %}
        <div class="alert alert-danger m-2 mb-3" role="alert">
            <i class="fa-solid fa-circle-exclamation me-2"></i>
            Some imported users are not valid! Please fix it!
        </div>
        {% endif %}


        <!-- All roles are picked Message? -->
        <div id="group-radio-message" class="alert alert-warning m-2 mb-3" role="alert">
            <i class="fa-solid fa-circle-exclamation me-2"></i>
            Please pick a group for each user!
        </div>

        <!-- Imporint Users Successful! -->
        <div id="importing-success" class="alert alert-success m-2 mb-3" role="alert">
            <i class="fa-solid fa-circle-exclamation me-2"></i>
            Importing Users Successful!
        </div>
        <!--  -->
        
        <!-- Accordion for the imported users -->
        <div class="accordion accordion-flush" id="accordion-users">
            {% for member in data %}
                <!-- Set the index of the user for easy usage -->
                {% set user_index = loop.index - 1  %}
                <div class="accordion-item">
                    <!-- Set the variables from the user info dictionary for easy usage -->
                    {% set user_valid = users_info[loop.index - 1]['user_valid']  %}
                    {% set user_update = users_info[loop.index - 1]['user_update']  %}
                    {% set username_valid = users_info[loop.index - 1]['username_valid']  %}
                    {% set email_valid = users_info[loop.index - 1]['email_valid']  %}

                    <!-- Accordion Header where it shows username and emails with importing status -->
                    <h2 class="accordion-header" id="heading-{{ user_index }}">
                        <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" 
                                data-bs-target="#collapse-{{ user_index }}" aria-expanded="false" 
                                aria-controls="collapse-{{ user_index }}">
                            {{ member.email }} - {{ member.username }}
                            <!-- Whether User is valid or invalid -->
                            {% if user_valid and user_update %}
                                <!-- User already exists and is valid -->
                                <i class="mx-2 fa-regular fa-pen-to-square" style="color: #fcc419;"
                                   data-bs-toggle="tooltip" data-bs-placement="top" 
                                   title="User already exist. Updating user!"></i>
                            {% elif user_valid %}
                                <!-- New Username and Email Valid! -->
                                <i class="mx-2 fa-check fa-solid" style="color: green;"></i>
                            {% else %}
                                <span class="mx-2">
                                    <!-- Username or Email or Groups Invalid! -->
                                    {% if username_valid == False %}
                                        <i class="mx-1 fa-solid fa-user" style="color: red;" 
                                        data-bs-toggle="tooltip" data-bs-placement="top" title="Username is already taken!"></i>
                                    {% endif %}

                                    {% if email_valid == False %}
                                        <i class="mx-1 fa-solid fa-envelope" style="color: red;"
                                        data-bs-toggle="tooltip" data-bs-placement="top" title="Email is already taken!"></i>
                                    {% endif %}
                                </span>

                            {% endif %}
                        </button>
                    </h2>

                    <!-- Accordion Body where it shows the user info -->
                    <div id="collapse-{{ user_index }}" class="accordion-collapse collapse" 
                            aria-labelledby="heading-{{ user_index }}" data-bs-parent="#accordion-users">
                        <div class="card">
                            <!-- Display the dictionary contents in a table -->
                            <div class="card-body">
                                <table class="table-sm">
                                    {% for key, value in member.items() %}
                                        <tr>
                                            <!-- Username and Email Identity --> 
                                            {% if key == "username" or key == "email" %}
                                                <td>{{ key }}:</td>
                                                <td>
                                                    {% if user_valid %}
                                                        <span>{{ value }}</span>
                                                    {% else %}
                                                        {% if (username_valid == False and key == "username") or (email_valid == False and key == "email")  %}
                                                            <span>{{ value }}</span><i class="mx-1 fa-solid fa-circle-exclamation" style="color: red;"></i>
                                                        {% else %}
                                                            <span>{{ value }}</span>
                                                        {% endif %}
                                                    {% endif %}
                                                </td>
                                                
                                            {% elif key == "attributes" %}
                                                <td>{{ key }}:</td>
                                                {% with items=value %}
                                                    {% include 'includes/simple-table.html' %}
                                                {% endwith %}
                                            {% elif key != "groups" and key != "roles" %}
                                                <td>{{ key }}:</td>
                                                <td>{{ value }}</td>
                                            {% endif %}
                                        </tr>
                                    {% endfor %}
                                        <tr>
                                            <td>groups:</td>
                                            <td>
                                                <!-- Groups -->
                                                <div class="form-check form-check-inline" id="group-{{user_index}}-groups">
                                                    {% for group in member.groups %}
                                                    <div class="form-check form-check-inline">
                                                        {% set group_index = loop.index - 1 %}
                                                        <input class="form-check-input role-radio" checked type="checkbox" name="{{group}}" value="{{group}}" id="group-{{group_index}}-{{user_index}}">
                                                        <label class="form-check-label" for="group-{{group_index}}-{{user_index}}">
                                                            {{group}}
                                                        </label>
                                                    </div>
                                                    {% endfor %}
                                                </div>
                                            </td>
                                        </tr>
                                        {% if roles %}
                                        <tr>
                                            <td>roles:</td>
                                            <td>
                                                <!-- Roles -->
                                                <div id="group-{{user_index}}-roles">
                                                {% for role in roles %}
                                                    {% set role_index = loop.index - 1 %}
                                                    <div class="form-check form-check-inline">
                                                        <input class="form-check-input role-radio" checked type="checkbox" name="{{role}}" value="{{role}}" id="role-{{role_index}}-{{user_index}}">
                                                        <label class="form-check-label" for="role-{{role_index}}-{{user_index}}">
                                                            {{role}}
                                                        </label>
                                                    </div>
                                                    {% endfor %}
                                                </div>
                                            </td>
                                        </tr>
                                        {% endif %}
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            {% endfor %}
        </div>
        <!--  -->
	{% endif %}
{% endblock %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}
<script>
    // Hide the importing and importing success messages
    $("#importing").hide()
    $("#importing-success").hide()

    // Make sure each user has group selected before enabling the importing users
    // let submitButton = $('#submitUsers');
    // Disable the button initially
    // submitButton.prop('disabled', true);

    /*$('#accordion-users').on('change', 'input[type="checkbox"]', function() {
        let importedUsers = {{ data | tojson }};
        let allRowsSelected = true;

        // Iterate over each row and check if a radio button is selected
        for (let i = 0; i < importedUsers.length; i++) {
            let group = $("input[name='group-" + i +"']:checked").val();
            if (group == undefined) {
                allRowsSelected = false;
                break; // Break out of the loop if a row is not selected
            }
        }
        if (allRowsSelected) { $("#group-radio-message").hide()}
        // Enable or disable the button based on whether all rows have a selected radio button
        submitButton.prop('disabled', !allRowsSelected);
    }); 
    */

    // For importing new users!
    $("#submitUsers").click( function(event) {
        let importedUsers = {{ data | tojson }}

        // check what group is selected for each user
        for (let i = 0; i < importedUsers.length; i++) {
            var selected = [];
            $('#group-'+ i + '-groups input:checked').each(function() {
                selected.push($(this).attr('name'));
            });
            importedUsers[i].groups = selected;
        }
        
        // check what roles is selected for each user
        for (let i = 0; i < importedUsers.length; i++) {
            var selected = [];
            $('#roles-'+ i + '-roles input:checked').each(function() {
                selected.push($(this).attr('name'));
            });
            importedUsers[i].roles = selected
        }
        
        $("#Actions").hide()
        $("#importing").show()

        $.ajax({
            type: "POST",
            url: "{{ url_for('users_import_blueprint.api_submit_users') }}",
            data: JSON.stringify({user: importedUsers, overwrite: $('#overwriteUsers')[0].checked}),
            processData: false,
            contentType: 'application/json',
            success: function(response) {
                $("#importing").hide()
                $("#import-button").hide()
                $("#importing-success").show()
            },
            error: function(error) {
                console.log(error.responseText)
                alert("Something went wrong check your Browser-Console for more information")
            }
        })
    })

    // Enable Tooltips
    var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
    var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
        return new bootstrap.Tooltip(tooltipTriggerEl)
    })
</script>


{% if config['DEBUG'] == True %}
<p>{{data}}</p>
{% endif %}

{% endblock javascripts %}
